SoleilEvent = {};
SoleilEvent_mt = Class(SoleilEvent, Event);

InitEventClass(SoleilEvent, "SoleilEvent");

function SoleilEvent:emptyNew()
    local self = Event:new(SoleilEvent_mt);
    self.className="SoleilEvent";
    return self;
end;

function SoleilEvent:new(object, SoleilMode)
    local self = SoleilEvent:emptyNew()
    self.object = object;
	self.SoleilMode = SoleilMode;
    return self;
end;

function SoleilEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
	self.SoleilMode = streamReadBool(streamId);
    self.object = networkGetObject(id);
    self:run(connection);
end;

function SoleilEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.object));
	streamWriteBool(streamId, self.SoleilMode);
end;

function SoleilEvent:run(connection)
	self.object:setSoleilMode(self.SoleilMode);
    if not connection:getIsServer() then
        g_server:broadcastEvent(SoleilEvent:new(self.object, self.SoleilMode), nil, connection, self.object);
    end;	
end;

function SoleilEvent.sendEvent(vehicle, SoleilMode, noEventSend)
	if SoleilMode ~= vehicle.SoleilMode then
		if noEventSend == nil or noEventSend == false then
			if g_server ~= nil then
				g_server:broadcastEvent(SoleilEvent:new(vehicle, SoleilMode), nil, nil, vehicle);
			else
				g_client:getServerConnection():sendEvent(SoleilEvent:new(vehicle, SoleilMode));
			end;
		end;
	end;
end;

